//
// Maurice Ribble
// 1-24-2005
//
// This is a driver for the L298 Motor Driver.  You can buy this motor driver
// from http://www.hobbyengineering.com/.
//

#define L298_ENABLE  PIN_C0
#define L298_I1      PIN_C1
#define L298_I2      PIN_C2
#define L298_I3      PIN_C3
#define L298_I4      PIN_C4

typedef enum {FORWARD, BACKWARD, STOP, OFF} motorDir;

// Depending on how you place the motors in your robot you may
// need to modify motor1() and motor2()

void motor1(motorDir dir)   // Left
{
    switch(dir)
    {
    case FORWARD:
        output_high(L298_ENABLE);
        output_high(L298_I1);
        output_low(L298_I2);
        break;
    case BACKWARD:
        output_high(L298_ENABLE);
        output_low(L298_I1);
        output_high(L298_I2);
        break;
    case STOP:
        output_high(L298_ENABLE);
        output_low(L298_I1);
        output_low(L298_I2);
        break;
    case OFF:
        output_low(L298_ENABLE);
        break;
    }
}

void motor2(motorDir dir)   // Right
{
    switch(dir)
    {
    case FORWARD:
        output_high(L298_ENABLE);
        output_high(L298_I3);
        output_low(L298_I4);
        break;
    case BACKWARD:
        output_high(L298_ENABLE);
        output_low(L298_I3);
        output_high(L298_I4);
        break;
    case STOP:
        output_high(L298_ENABLE);
        output_low(L298_I3);
        output_low(L298_I4);
        break;
    case OFF:
        output_low(L298_ENABLE);
        break;
    }
}

void motorsForward()
{
    motor1(FORWARD);
    motor2(FORWARD);
}

void motorsBackward()
{
    motor1(BACKWARD);
    motor2(BACKWARD);
}

void motorsLeft()
{
    motor1(STOP);
    motor2(FORWARD);
}

void motorsRight()
{
    motor1(FORWARD);
    motor2(STOP);
}

void motorsSpinLeft()
{
    motor1(BACKWARD);
    motor2(FORWARD);
}

void motorsSpinRight()
{
    motor1(FORWARD);
    motor2(BACKWARD);
}

void motorsStop()
{
    motor1(STOP);
    motor2(STOP);
}

void motorsOff()
{
    // Turning one motor off, turns them both off 
    motor1(OFF);
}

